// IR-inspector 
// detects IR activity on pin 2 (digital in) and reports signal times (in s) on serial
// the pin 2 state is passed-through to the pin 13 as output

int state = 0;
int current = 0;

unsigned long base = 0, tim = 0;

long mem[256];
int memp = 0, i = 0;

void setup()
{
  Serial.begin(9600);
  pinMode(2, INPUT); // the default actually
  pinMode(13, OUTPUT);
  // flash to signal we're ready
  digitalWrite(13, HIGH);
  delay(200);
  digitalWrite(13, LOW);
  delay(200);
  digitalWrite(13, HIGH);
  delay(200);
  digitalWrite(13, LOW);
  base = micros();
  Serial.print("IR-detector is ready.\r\n");
}

void loop()
{
  current = digitalRead(2);
  if (current != state) {
    tim = micros();
    tim -= base;
    if (memp < 256) {
      mem[memp++] = tim;
    } else {
      Serial.print(state);
      Serial.print(" o: ");
      i = 0; while (i < memp) {
        Serial.print(mem[i++]); Serial.print(" ");
      }
      Serial.print("\r\n");
      memp = 0;
    }
    base += tim;
    state = current;
    digitalWrite(13, (state == 0) ? LOW : HIGH);
  } else if (base != 0 && memp > 0 && micros() - base > 1000000L) {
    Serial.print(state);
    Serial.print("> rep: ");
    i = 0; while (i < memp) {
      Serial.print(mem[i++]); Serial.print(" ");
    }
    Serial.print("\r\n");
    memp = 0;
  }
}
